//
//  GameConfig.h
//  Lumio
//
//  Created by Joanne Dyer on 1/19/13.
//  Copyright 2013 Joanne Dyer. All rights reserved.
//

//File contains all the values used to configure the game.
#ifndef GameConfig_h
#define GameConfig_h

//GAME POSITIONS
//main game area positions.
#define GAME_AREA_X_COORD 10
#define GAME_AREA_Y_COORD 37
#define SQUARE_SIDE_LENGTH 43
#define NUMBER_OF_ROWS 9
#define NUMBER_OF_COLUMNS 7
#define MIDDLE_ROW_INDEX 4
#define MIDDLE_COLUMN_INDEX 3
//header positions.
#define HEADER_X_COORD 160
#define HEADER_Y_COORD 455
#define EXPLICIT_FOUR_INCH_SCREEN_HEADER_Y_COORD 509
#define COUNTDOWN_BAR_X_COORD 10
#define COUNTDOWN_BAR_Y_COORD 436
#define EXPLICIT_FOUR_INCH_SCREEN_COUNTDOWN_BAR_Y_COORD 490
#define PAUSE_X_COORD 287
#define PAUSE_Y_COORD 455
#define EXPLICIT_FOUR_INCH_SCREEN_PAUSE_Y_COORD 509
//footer positions.
#define FOOTER_X_COORD 160
#define FOOTER_Y_COORD 17
#define EXPLICIT_FOUR_INCH_SCREEN_FOOTER_Y_COORD 51
#define LEVEL_X_COORD 73
#define LEVEL_Y_COORD 16
#define EXPLICIT_FOUR_INCH_SCREEN_LEVEL_Y_COORD 50
#define LEVEL_WIDTH 106
#define LEVEL_HEIGHT 26
#define SCORE_X_COORD 253
#define SCORE_Y_COORD 16
#define EXPLICIT_FOUR_INCH_SCREEN_SCORE_Y_COORD 50
#define SCORE_WIDTH 136
#define SCORE_HEIGHT 26
#define STAR_SPRITE_X_COORD 125
#define STAR_SPRITE_Y_COORD 17
#define EXPLICIT_FOUR_INCH_SCREEN_STAR_SPRITE_Y_COORD 51
#define STARS_REMAINING_X_COORD 155
#define STARS_REMAINING_Y_COORD 16
#define EXPLICIT_FOUR_INCH_SCREEN_STAR_REMAINING_Y_COORD 50
#define STARS_REMAINING_WIDTH 40
#define STARS_REMAINING_HEIGHT 26

//MENUS
//intro
#define INTRO_TRANSITION_TIME 1.0
//main menu
#define LOGO_X_COORD 160
#define LOGO_Y_COORD 347
#define MAIN_MENU_MENU_X_COORD 160
#define MAIN_MENU_MENU_Y_COORD 190
//about
#define ABOUT_TITLE_X_COORD 160
#define ABOUT_TITLE_Y_COORD 340
#define ABOUT_MENU_X_COORD 160
#define ABOUT_MENU_Y_COORD 218
//settings
#define SETTINGS_TITLE_X_COORD 160
#define SETTINGS_TITLE_Y_COORD 330
#define SOUND_EFFECTS_TITLE_X_COORD 160
#define SOUND_EFFECTS_TITLE_Y_COORD 275
#define SOUND_EFFECTS_TOGGLE_X_COORD 160
#define SOUND_EFFECTS_TOGGLE_Y_COORD 240
#define MUSIC_TITLE_X_COORD 160
#define MUSIC_TITLE_Y_COORD 195
#define MUSIC_TOGGLE_X_COORD 160
#define MUSIC_TOGGLE_Y_COORD 160
//credits
#define LICENSE_X_COORD 158
#define LICENSE_Y_COORD 182
//ingame
#define PAUSED_LABEL_X_COORD 90
#define PAUSED_LABEL_Y_COORD 285
#define PAUSED_LABEL_ANCHOR_X_COORD 0
#define PAUSED_LABEL_ANCHOR_Y_COORD 0
#define PAUSED_LABEL_WIDTH 140
#define PAUSED_LABEL_HEIGHT 45
#define SCORE_LABEL_X_COORD 90
#define SCORE_LABEL_Y_COORD 285
#define SCORE_LABEL_ANCHOR_X_COORD 0
#define SCORE_LABEL_ANCHOR_Y_COORD 0
#define SCORE_LABEL_WIDTH 140
#define SCORE_LABEL_HEIGHT 45
#define HIGH_SCORE_LABEL_X_COORD 90
#define HIGH_SCORE_LABEL_Y_COORD 235
#define HIGH_SCORE_LABEL_ANCHOR_X_COORD 0
#define HIGH_SCORE_LABEL_ANCHOR_Y_COORD 0
#define HIGH_SCORE_LABEL_WIDTH 140
#define HIGH_SCORE_LABEL_HEIGHT 45
#define RESUME_BUTTON_X_COORD 160
#define RESUME_BUTTON_Y_COORD 240
#define RESTART_BUTTON_X_COORD 160
#define RESTART_BUTTON_Y_COORD 200
#define MENU_BUTTON_X_COORD 160
#define MENU_BUTTON_Y_COORD 160
//background circles
#define CIRCLE_1_X_COORD 204
#define CIRCLE_1_Y_COORD 456
#define CIRCLE_1_INITIAL_TIME 24
#define CIRCLE_2_X_COORD 39
#define CIRCLE_2_Y_COORD 390
#define CIRCLE_2_INITIAL_TIME 12
#define CIRCLE_3_X_COORD 160
#define CIRCLE_3_Y_COORD 320
#define CIRCLE_3_INITIAL_TIME 8
#define CIRCLE_4_X_COORD 74
#define CIRCLE_4_Y_COORD 204
#define CIRCLE_4_INITIAL_TIME 20
#define CIRCLE_5_X_COORD 244
#define CIRCLE_5_Y_COORD 168
#define CIRCLE_5_INITIAL_TIME 16
#define CIRCLE_6_X_COORD 115
#define CIRCLE_6_Y_COORD 65
#define CIRCLE_6_INITIAL_TIME 4
#define MAX_CIRCLE_TIME 24
#define MENU_CIRCLE_OPACITY 30
//general
#define MENU_PADDING 10.0
#define MENU_TRANSITION_TIME 0.6
#define BACK_X_COORD 76
#define BACK_Y_COORD 51
#define EXPLICIT_FOUR_INCH_SCREEN_BACK_Y_COORD 61
#define NEXT_X_COORD 250
#define NEXT_Y_COORD 51
#define EXPLICIT_FOUR_INCH_SCREEN_NEXT_Y_COORD 61
#define MENU_CRITICAL_THRESHOLD 0.2

//LIGHTS
//setup
#define PERCENTAGE_OF_LIGHTS_START_ON_COOLDOWN 25
#define PERCENTAGE_OF_LIGHTS_START_ON_MAX_COUNTDOWN 10
//animation
#define MAX_RADIUS 25
#define MIN_RADIUS 20.0
#define SPEED_UP_THRESHOLD 0.5
#define CRITICAL_THRESHOLD 0.1
#define OUTER_CIRCLE_OPACITY 150
//timers
#define MAX_REFRESH_COUNTDOWN 14
#define MIN_REFRESH_COUNTDOWN 11
#define MAX_SPAWN_COUNTDOWN 13
#define MIN_SPAWN_COUNTDOWN 10
#define INITIAL_COUNTDOWN_REDUCTION 0
#define COUNTDOWN_REDUCTION_PER_LEVEL 0.2
#define MAX_COUNTDOWN_REDUCTION 5
#define MIN_COOLDOWN 7
#define INITIAL_MAX_COOLDOWN 30
#define MAX_COOLDOWN_INCREASE 0.5
#define CHARGE_TIME 0
#define NEW_VALUE_DELAY_IN_SECONDS 1.5

//PLAYER
#define SPEED_IN_POINTS_PER_SECOND 150.0

//COUNTDOWN
//speeds
#define INITIAL_COUNTDOWN_SPEED_IN_PERCENTAGE_PER_SECOND 4.0
#define LEVEL_1_TO_5_COUNTDOWN_SPEED_INCREASE 1.0
#define LEVEL_6_TO_10_COUNTDOWN_SPEED_INCREASE 0.3
#define LEVEL_11_TO_20_COUNTDOWN_SPEED_INCREASE 0.2
#define LEVEL_21_ONWARDS_COUNTDOWN_SPEED_INCREASE 0.1
//increases
#define COUNTDOWN_HIGH_INCREASE_PERCENTAGE 48.0
#define COUNTDOWN_MEDIUM_INCREASE_PERCENTAGE 36.0
#define COUNTDOWN_LOW_INCREASE_PERCENTAGE 24.0
//animation
#define COUNTDOWN_BAR_GLOW_TIME 1.0
#define COUNTDOWN_WARNING_START_PERCENTAGE 30.0

//LEVEL
#define STARS_TO_LEVEL_UP 10
#define MAX_LEVEL 999

//SCORE
#define SCORE_FOR_HIGH_VALUE 375
#define SCORE_FOR_MEDIUM_VALUE 250
#define SCORE_FOR_LOW_VALUE 125
#define MAX_SCORE 999999

//COLOURS
#define STANDARD_PURPLE ccc3(160, 48, 252)
#define STANDARD_PINK ccc3(184, 108, 252)
#define STANDARD_BLUE ccc3(3, 171, 255)
#define STANDARD_BACKGROUND ccc4(15, 15, 15, 255)
#define OPAQUE 255
#define TRANSPARENT 0

//FONTS
#define FONT_NAME @"Helvetica"
#define FONT_SIZE 19

//SOUNDS
#define SOUND_EFFECTS_ON_KEY @"soundEffectsOnKey"
#define MUSIC_ON_KEY @"musicOnKey"
#define FIRST_PLAY_KEY @"firstPlayKey"
#define SOUND_EFFECTS_VOLUME 0.15f
#define MUSIC_VOLUME 0.2f
#define SILENT 0.0

//MISC
#define GAME_LAYER_TAG 1
#define HIGH_SCORE_CATEGORY @"1"
#define APPLE_ID @"608072046"
#define FOUR_INCH_SCREEN_HEIGHT_ADJUSTMENT 44

#endif
